diff --git a/core/arch/instr_shared.c b/core/arch/instr_shared.c
index c4ff564f30..867744f2e5 100644
--- a/core/arch/instr_shared.c
+++ b/core/arch/instr_shared.c
@@ -1299,7 +1299,13 @@ instr_expand(dcontext_t *dcontext, instrlist_t *ilist, instr_t *instr)
         !instr_valid(instr))
         return instr;
 
-    DOLOG(5, LOG_ALL, { loginst(dcontext, 4, instr, "instr_expand"); });
+    DOLOG(5, LOG_ALL, {
+        /* disassembling might change the instruction object, we're cloning it
+         * for the logger */
+        instr_t *log_instr = instr_clone(dcontext, instr);
+        loginst(dcontext, 4, log_instr, "instr_expand");
+        instr_free(dcontext, log_instr);
+    });
 
     /* decode routines use dcontext mode, but we want instr mode */
     dr_set_isa_mode(dcontext, instr_get_isa_mode(instr), &old_mode);
diff --git a/core/unix/native_elf.c b/core/unix/native_elf.c
index 5b69b98d40..544ac95f01 100644
--- a/core/unix/native_elf.c
+++ b/core/unix/native_elf.c
@@ -125,24 +125,24 @@ find_dl_fixup(dcontext_t *dcontext, app_pc resolver)
 {
 #ifdef X86
     instr_t instr;
-    int max_decodes = 30;
+    const int max_decodes = 225;
     int i = 0;
     app_pc pc = resolver;
     app_pc fixup = NULL;
 
-    LOG(THREAD, 5, LOG_LOADER, "%s: scanning for _dl_fixup call:\n", __FUNCTION__);
+    LOG(THREAD, LOG_LOADER, 5, "%s: scanning for _dl_fixup call:\n", __FUNCTION__);
     instr_init(dcontext, &instr);
-    while (pc != NULL && i < max_decodes) {
+    while (pc != NULL && i++ < max_decodes) {
         DOLOG(5, LOG_LOADER, { disassemble(dcontext, pc, THREAD); });
         pc = decode(dcontext, pc, &instr);
         if (instr_get_opcode(&instr) == OP_call) {
             opnd_t tgt = instr_get_target(&instr);
             fixup = opnd_get_pc(tgt);
-            LOG(THREAD, 1, LOG_LOADER,
+            LOG(THREAD, LOG_LOADER, 1,
                 "%s: found _dl_fixup call at " PFX ", _dl_fixup is " PFX ":\n",
                 __FUNCTION__, pc, fixup);
             break;
-        } else if (instr_is_cti(&instr)) {
+        } else if (instr_is_return(&instr)) {
             break;
         }
         instr_reset(dcontext, &instr);
